Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
VrpnClient Class Reference

A specific ClientBase that connects to a VRPN server and records information on the connected VRPN devices. More...

`#include "vrpnClient.h"`

Inheritance diagram for VrpnClient:

## Public Member Functions
| VrpnClient (const std::string &server_name)
virtual TypeHandle | force_init_type ()
const std::string & | get_server_name () const
| Returns the name of the server as passed to the VrpnClient constructor.
virtual TypeHandle | get_type () const
bool | is_connected () const
| Returns true if the connection is established successfully, false otherwise.
bool | is_valid () const
| Returns true if everything seems to be kosher with the server (even if there is no connection), or false otherwise.
void | write (std::ostream &out, int indent_level=0) const
| Writes a list of the active devices that the VrpnClient is currently polling each frame.
Public Member Functions inherited from ClientBase
bool | fork_asynchronous_thread (double poll_time)
| Forks a separate thread to do all the polling of connected devices.
CoordinateSystem | get_coordinate_system () const
| Returns the coordinate system that all devices associated with this client will operate in.
PointerTo< ClientDevice > | get_device (TypeHandle device_type, const std::string &device_name)
| Returns a ClientDevice pointer that corresponds to the named device of the indicated device type.
double | get_last_poll_time () const
| Returns the time (according to the global ClockObject's get_real_time() method) of the last device poll.
bool | is_forked () const
| Returns true if the ClientBase has been forked (and, therefore, poll() does not need to be called), false otherwise.
bool | poll ()
| Initiates a poll of the client devices, if we are not forked and if we have not already polled this frame.
void | set_coordinate_system (CoordinateSystem cs)
| Specifies the coordinate system that all devices associated with this client will operate in.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static double | convert_to_secs (struct timeval msg_time)
| Little inline function to convert a struct timeval to only seconds.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from ClientBase
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

A specific ClientBase that connects to a VRPN server and records information on the connected VRPN devices.

Definition at line 35 of file vrpnClient.h.

## Constructor & Destructor Documentation

## ◆ VrpnClient()

VrpnClient::VrpnClient | ( | const std::string & | server_name | ) |
| explicit

Definition at line 36 of file vrpnClient.cxx.

## ◆ ~VrpnClient()

VrpnClient::~VrpnClient | ( |  | ) |

Definition at line 58 of file vrpnClient.cxx.

## Member Function Documentation

## ◆ convert_to_secs()

double VrpnClient::convert_to_secs | ( | struct timeval | msg_time | ) |
| inline static

Little inline function to convert a struct timeval to only seconds.

Definition at line 25 of file vrpnClient.I.

## ◆ force_init_type()

virtual TypeHandle VrpnClient::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from ClientBase.

Definition at line 108 of file vrpnClient.h.

## ◆ get_class_type()

static TypeHandle VrpnClient::get_class_type | ( |  | ) |
| inline static

Definition at line 97 of file vrpnClient.h.

## ◆ get_server_name()

const std::string & VrpnClient::get_server_name | ( |  | ) | const
| inline

Returns the name of the server as passed to the VrpnClient constructor.

Definition at line 17 of file vrpnClient.I.

## ◆ get_type()

virtual TypeHandle VrpnClient::get_type | ( |  | ) | const
| inline virtual

Reimplemented from ClientBase.

Definition at line 105 of file vrpnClient.h.

## ◆ init_type()

static void VrpnClient::init_type | ( |  | ) |
| inline static

Definition at line 100 of file vrpnClient.h.

## ◆ is_connected()

bool VrpnClient::is_connected | ( |  | ) | const

Returns true if the connection is established successfully, false otherwise.

Definition at line 76 of file vrpnClient.cxx.

Referenced by write().

## ◆ is_valid()

bool VrpnClient::is_valid | ( |  | ) | const

Returns true if everything seems to be kosher with the server (even if there is no connection), or false otherwise.

Definition at line 67 of file vrpnClient.cxx.

Referenced by write().

## ◆ write()

void VrpnClient::write | ( | std::ostream & | out,
|  | int | indent_level = 0 ) const

Writes a list of the active devices that the VrpnClient is currently polling each frame.

Definition at line 85 of file vrpnClient.cxx.

References indent(), is_connected(), and is_valid().

The documentation for this class was generated from the following files:

- panda/src/vrpn/vrpnClient.h
- panda/src/vrpn/vrpnClient.cxx
- panda/src/vrpn/vrpnClient.I